package appia.protocols.stf.rrpc;

import appia.*;
import appia.events.*;

/**
 * Classe que define os eventos que esta camada
 * aceita, precisa e fornece.
 * Pode ser necessario adicionar eventos novos.
 */
public class RRPCLayer extends Layer {
    
    public RRPCLayer() {
	try {
	    Class cinit=Class.forName("appia.events.channel.ChannelInit");
	    Class cclose=Class.forName("appia.events.channel.ChannelClose");
	    Class send=Class.forName("appia.events.SendableEvent");
	    Class rv=Class.forName("appia.protocols.remoteView.RemoteViewEvent");

	    evProvide=new Class[1];
	    evProvide[0]=rv;

	    evRequire= new Class[0];
	    
	    evAccept=new Class[4];
	    evAccept[0]=rv;
	    evAccept[1]=cinit;
	    evAccept[2]=cclose;
	    evAccept[3]=send;


	    
	} catch (ClassNotFoundException ex) {
	    ex.printStackTrace();
	    throw new AppiaError("RRPCLayer: !!!!!!");
	}
    }
    
    public Session createSession() {
	return new RRPCSession(this);
    }
}
